"use strict";
/*--------------------------------------------------------*\
|                                                          |
|                          hprose                          |
|                                                          |
| Official WebSite: https://hprose.com                     |
|                                                          |
| Provider.ts                                              |
|                                                          |
| Provider for TypeScript.                                 |
|                                                          |
| LastModified: Feb 24, 2019                               |
| Author: Ma Bingyao <andot@hprose.com>                    |
|                                                          |
\*________________________________________________________*/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rpc_core_1 = require("@hprose/rpc-core");
var ProviderContext = /** @class */ (function (_super) {
    __extends(ProviderContext, _super);
    function ProviderContext(client, method) {
        var _this = _super.call(this) || this;
        _this.client = client;
        _this.method = method;
        return _this;
    }
    return ProviderContext;
}(rpc_core_1.Context));
exports.ProviderContext = ProviderContext;
var Provider = /** @class */ (function () {
    function Provider(client, id) {
        this.client = client;
        this.closed = true;
        this.debug = false;
        this.methodManager = new rpc_core_1.MethodManager();
        this.invokeManager = new rpc_core_1.InvokeManager(this.execute.bind(this));
        if (id)
            this.id = id;
        this.add(new rpc_core_1.Method(this.methodManager.getNames, '~', this.methodManager));
    }
    Object.defineProperty(Provider.prototype, "id", {
        get: function () {
            if (this.client.requestHeaders['id']) {
                return this.client.requestHeaders['id'].toString();
            }
            throw new Error('client unique id not found');
        },
        set: function (value) {
            this.client.requestHeaders['id'] = value;
        },
        enumerable: true,
        configurable: true
    });
    Provider.prototype.execute = function (name, args, context) {
        return __awaiter(this, void 0, void 0, function () {
            var method;
            return __generator(this, function (_a) {
                method = context.method;
                return [2 /*return*/, method.method.apply(method.target, method.missing ? method.passContext ? [name, args, context] : [name, args] : args)];
            });
        });
    };
    Provider.prototype.process = function (call) {
        return __awaiter(this, void 0, void 0, function () {
            var index, name, args, method, context, _a, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        index = call[0], name = call[1], args = call[2];
                        method = this.get(name);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        if (method === undefined) {
                            throw new Error('Can\'t find this method ' + name + '().');
                        }
                        context = new ProviderContext(this.client, method);
                        if (!method.missing && method.passContext)
                            args.push(context);
                        _a = [index];
                        return [4 /*yield*/, this.invokeManager.handler(name, args, context)];
                    case 2: return [2 /*return*/, _a.concat([_b.sent(), undefined])];
                    case 3:
                        e_1 = _b.sent();
                        return [2 /*return*/, [index, undefined, this.debug ? e_1.stack ? e_1.stack : e_1.message : e_1.message]];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Provider.prototype.dispatch = function (calls) {
        return __awaiter(this, void 0, void 0, function () {
            var n, results, i, _a, _b, _c, e_2;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        n = calls.length;
                        results = new Array(n);
                        for (i = 0; i < n; ++i) {
                            results[i] = this.process(calls[i]);
                        }
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 4, , 5]);
                        _b = (_a = this.client).invoke;
                        _c = ['='];
                        return [4 /*yield*/, Promise.all(results)];
                    case 2: return [4 /*yield*/, _b.apply(_a, _c.concat([[_d.sent()]]))];
                    case 3:
                        _d.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        e_2 = _d.sent();
                        if (this.onerror) {
                            this.onerror(e_2);
                        }
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    Provider.prototype.listen = function () {
        return __awaiter(this, void 0, void 0, function () {
            var calls, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.closed = false;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.client.invoke('!', [], Array)];
                    case 2:
                        calls = _a.sent();
                        if (!calls)
                            return [2 /*return*/];
                        this.dispatch(calls);
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _a.sent();
                        if (this.onerror) {
                            this.onerror(e_3);
                        }
                        return [3 /*break*/, 4];
                    case 4:
                        if (!this.closed) return [3 /*break*/, 1];
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    Provider.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.closed = true;
                        return [4 /*yield*/, this.client.invoke('!!')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Provider.prototype.use = function () {
        var handlers = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            handlers[_i] = arguments[_i];
        }
        var _a;
        (_a = this.invokeManager).use.apply(_a, handlers);
        return this;
    };
    Provider.prototype.unuse = function () {
        var handlers = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            handlers[_i] = arguments[_i];
        }
        var _a;
        (_a = this.invokeManager).unuse.apply(_a, handlers);
        return this;
    };
    Provider.prototype.get = function (fullname) {
        return this.methodManager.get(fullname);
    };
    Provider.prototype.add = function (method) {
        this.methodManager.add(method);
        return this;
    };
    Provider.prototype.remove = function (fullname) {
        this.methodManager.remove(fullname);
        return this;
    };
    Provider.prototype.addFunction = function (f, fullname) {
        this.methodManager.addFunction(f, fullname);
        return this;
    };
    Provider.prototype.addMethod = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var _a;
        (_a = this.methodManager).addMethod.apply(_a, [args[0], args[1]].concat(args.slice(2)));
        return this;
    };
    Provider.prototype.addMissingMethod = function (fn, target) {
        this.methodManager.addMissingMethod(fn, target);
        return this;
    };
    Provider.prototype.addFunctions = function (functions, fullnames) {
        this.methodManager.addFunctions(functions, fullnames);
        return this;
    };
    Provider.prototype.addMethods = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var _a;
        (_a = this.methodManager).addMethods.apply(_a, [args[0], args[1]].concat(args.slice(2)));
        return this;
    };
    Provider.prototype.addInstanceMethods = function (target, prefix) {
        this.methodManager.addInstanceMethods(target, prefix);
        return this;
    };
    return Provider;
}());
exports.Provider = Provider;
//# sourceMappingURL=Provider.js.map